Ubuntu

Libfaac not LGPL

Reported by Reinhard Tartler on 2009-05-11
148
This bug affects 21 people
Affects Status Importance Assigned to Milestone
ubuntu-community
Undecided
Ubuntu Technical Board
faac (Ubuntu)
High
Unassigned

Bug Description

Binary package hint: faac

From: Jason Garrett-Glaser <email address hidden>
Subject: [RFC] Libfaac not LGPL?
Newsgroups: gmane.comp.video.ffmpeg.devel
To: FFmpeg development discussions and patches <email address hidden>
Date: Mon, 27 Apr 2009 16:45:37 -0700
Reply-To: FFmpeg development discussions and patches
 <email address hidden>

We had some discussions on #ffmpeg-devel and I asked the folks at #gnu
about this:

http://faac.cvs.sourceforge.net/viewvc/faac/faac/libfaac/tns.c?r1=1.8&r2=1.9

It appears that libfaac, despite declaring itself LGPL2.1, contains
quite a few licenses... many of which are completely incompatible with
the LGPL, such as the above.

In theory, it still may be legal to distribute, as the LGPL linking
exception *may* cover the linking of .c files with non-free licenses
with .c files that have free licenses. However, either way, this
places FAAC squarely under non-GPL territory... such that ffmpeg
should require --enable-nonfree to link to it.

See thread at http://comments.gmane.org/gmane.comp.video.ffmpeg.devel/89985

Related branches

description: updated
Reinhard Tartler (siretart) wrote :

Affected files:
 - libfaac/bitstream.c
 - libfaac/tns.c
 - libfaac/tns.h

copyright notice:
This software module was originally developed by
and edited by Texas Instruments in the course of
development of the MPEG-2 NBC/MPEG-4 Audio standard
ISO/IEC 13818-7, 14496-1,2 and 3. This software module is an
implementation of a part of one or more MPEG-2 NBC/MPEG-4 Audio tools
as specified by the MPEG-2 NBC/MPEG-4 Audio standard. ISO/IEC gives
users of the MPEG-2 NBC/MPEG-4 Audio standards free license to this
software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-2 NBC/ MPEG-4 Audio
standards. Those intending to use this software module in hardware or
software products are advised that this use may infringe existing
patents. The original developer of this software module and his/her
company, the subsequent editors and their companies, and ISO/IEC have
no liability for use of this software module or modifications thereof
in an implementation. Copyright is not released for non MPEG-2
NBC/MPEG-4 Audio conforming products. The original developer retains
full right to use the code for his/her own purpose, assign or donate
the code to a third party and to inhibit third party from using the
code for non MPEG-2 NBC/MPEG-4 Audio conforming products. This
copyright notice must be included in all copies or derivative works.

Copyright (c) 1997.

Changed in faac (Ubuntu):
importance: Undecided → High
status: New → Triaged

Hi,

It has been suggested to me that I should contact you and ask for
clarification for the license of faac. Allow me to introduce myself, I'm
both and Debian and Ubuntu Developer and maintain several multimedia
related packages in the Debian pkg-multimedia team.

It has come to my attention that ffmpeg and x264 developers claim that faac
cannot be redistributed under the LGPL. According to my investigations,
this claim arises from using the following files:

 - libfaac/bitstream.c
 - libfaac/tns.c
 - libfaac/tns.h

All contain the following copyright notice:

This software module was originally developed by
and edited by Texas Instruments in the course of
development of the MPEG-2 NBC/MPEG-4 Audio standard
ISO/IEC 13818-7, 14496-1,2 and 3. This software module is an
implementation of a part of one or more MPEG-2 NBC/MPEG-4 Audio tools
as specified by the MPEG-2 NBC/MPEG-4 Audio standard. ISO/IEC gives
users of the MPEG-2 NBC/MPEG-4 Audio standards free license to this
software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-2 NBC/ MPEG-4 Audio
standards. Those intending to use this software module in hardware or
software products are advised that this use may infringe existing
patents. The original developer of this software module and his/her
company, the subsequent editors and their companies, and ISO/IEC have
no liability for use of this software module or modifications thereof
in an implementation. Copyright is not released for non MPEG-2
NBC/MPEG-4 Audio conforming products. The original developer retains
full right to use the code for his/her own purpose, assign or donate
the code to a third party and to inhibit third party from using the
code for non MPEG-2 NBC/MPEG-4 Audio conforming products. This
copyright notice must be included in all copies or derivative works.

Copyright (c) 1997.

This issue is tracked publicly in the ubuntu bug tracking system at
https://launchpad.net/bugs/374900

I strongly suspect that this is not intended and there might either be a
misunderstanding or can be fixed otherwise easily.

Could you please state us you your opinion on the matter and advice us
how to proceed with the ubuntu package in ubuntu? If you don't mind, I'd
like to copy your answer to the bug referenced above.

Thanks for releasing faac under LGPL and thanks in advance for
considering this issue!

--
Gruesse/greetings,
Reinhard Tartler, KeyID 945348A4

Wes Garner (wesgarner) wrote :

Just an example of an attempt to use libfaac with ffmpeg:
https://bugs.launchpad.net/bugs/412063

Please help us sort this out, so this will be available for Ubuntu users.
Depending on the actual outcome for the LGPL licensing, shouldn't this at least be set up for people using non-free (ex Medibuntu packages) codecs

markhaven (markbhaven-yo) wrote :

This is complete and utter nonesense. The referred code needs to be re-instigated immediately. If the alleged IP owners ask for it to be removed then it should be.. otherwise, why is it being pre-emptively censored and on who's authority?

Even if patent/copyright exists - there are hundreds of implementations of this particular code in numerous open source applications. The supposed owners have made no recorded attempt to restrict use of AAC and other codecs for the last 12 years. In addition, the MP3 and AAC codecs pre-date the statement by a considerable time. All very mysterious....

Anyone can claim they own the copyright to some code - have they provided proof which has been independently validated?

Either way, this appears an obvious attempt to cripple ubuntu and devalue Linux as a tool for media transcoding... An investigation of who is behind these claims would be interesting...

Wes Garner (wesgarner) wrote :

I wanted to do a bump on this to see if Upstream has taken any look at this. Who are we to assign this to for someone to look at it?

Soos Gergely (sogerc1) wrote :

Is anyone paying attention to this issue anymore?
As I already mentioned in bug 412063 I would need the aac because the only other alternative audio codec my phone supports is amr which delivers unacceptable audio quality.
Maybe I'm too dumb but I can't understand why can't there be an ffmpeg in Medibuntu that uses faac. Isn't the purpose of medibuntu to transfer the legal responsibility to whoever uses it? I already waited almost one full month; if I have to wait God knows how much more time can at least someone explain to me in layman's terms why isn't there a medibuntu package?

Soos Gergely wrote:
> I already waited almost one full month; if I have to wait
> God knows how much more time can at least someone explain to me in
> layman's terms why isn't there a medibuntu package?

I would say this part is easy. Probably because nobody has requested the
 Medibuntu maintainers to make one. I just submitted a wish-list bug
490227
for Medibuntu. Lets see if they can help.

Soos Gergely (sogerc1) wrote :

Thank you very much Paul, I'm keeping my fingers crossed.

Reinhard Tartler (siretart) wrote :

subscribing ubuntu archive administrators:

could you please review the legal status of the faac package?

In the meantime I've found this statement on the upstream homepage: http://www.audiocoding.com/faac.html

<quote>
FAAC is based on the original ISO MPEG reference code. The changes to this code are licensed under the LGPL license. The original license is not compatible with the LGPL, please be aware of this when using FAAC. The original license text can be found in the README file included in the download package.
</quote>

Gilbert Mendoza (gmendoza) wrote :

Lionel Le Folgoc made this comment, and submitted a number of libavcodec packages that include faac support.

https://bugs.launchpad.net/medibuntu/+bug/490227/comments/1

For the impatient, add the following line to your medibuntu repo list.

deb http://packages.medibuntu.org/ karmic-staging free non-free

Already tested. Works great.

Paul Gevers (paul-climbing) wrote :

> For the impatient, add the following line to your medibuntu repo list.
>
> deb http://packages.medibuntu.org/ karmic-staging free non-free

And ONLY for the impatient. You should be willing to test if nothing
breaks and report back if it does. Otherwise wait one week and use
karmic instead of karmic-staging.

Reinhard Tartler (siretart) wrote :

another license review on the ffmpeg mailing list:

http://thread.gmane.org/gmane.comp.video.ffmpeg.devel/103514

James Westby (james-w) wrote :

So, by my reading this makes libfaac undistributable, due to the conflict between
the LGPL and this license, as well as possible ambiguity as to whether we would
even be able to use the code under the original license (do we "claim[...] conformance
to the MPEG-2 NBC/ MPEG-4 Audio standards?")

Therefore it looks to me as though this package should not even be in multiverse.

I'm not going to act on this until we have consensus between ubuntu-archive and
Reinhard though.

There are a few packages that would be impacted by its removal:

  divxenc
  h264enc
  ripit
  avidemux-plugins-common
  gstreamer0.10-plugins-bad-multiverse
  mencoder
  mplayer
  mplayer-gui
  ogmrip
  xvidenc

Thanks,

James

Reinhard Tartler (siretart) wrote :

nearly all of them only use aac optionally and can be fixed to not build
aganst libfaac.

removing faac will annoy our users pretty badly, since it is the most
common way to create AAC audio. I hope that removing it will motivate
(more) people to contribute to ffaac, ffmpeg's internal AAC encoder,
which still lacks some features only libfaac has.

Savvas Radevic (medigeek) wrote :

Is the internal codec, ffaac, going to be included with 10.04 ffmpeg? I mean, is there going to an alternative solution provided?

Savvas Radevic (medigeek) wrote :

> with 10.04 ffmpeg
I mean with ubuntu 10.04 ffmpeg package

Reinhard Tartler (siretart) wrote :

10.04 will ship ffmpeg 0.5, which does not include an aac encoder.

if libfaac is removed, ubuntu 10.04 will not contain any useable AAC encoder.

Jim Louvau (jlouvau) wrote :

Yes! Great idea! Lets forget all about "it just works." Lets
annoy/piss-off/confuse/break hundreds if not thousands of unaware end-users
by including, without knowledge or consent, into our little battle to
further our cause. Thank you for for deciding that we should all be part of
some little pissing contest. We will be ever so grateful that the wonderful,
all knowing and all seeing "developers" deigned to include all of us in
their holy war. Ooohhh lucky us!

Sorry, but the "lets piss off all of the users to further our agenda"
attitude is intolerably arrogant at best and most certainly isn't a
solution.

On Tue, Mar 30, 2010 at 2:34 AM, Reinhard Tartler <email address hidden>wrote:

> nearly all of them only use aac optionally and can be fixed to not build
> aganst libfaac.
>
> removing faac will annoy our users pretty badly, since it is the most
> common way to create AAC audio. I hope that removing it will motivate
> (more) people to contribute to ffaac, ffmpeg's internal AAC encoder,
> which still lacks some features only libfaac has.
>
> --
> Libfaac not LGPL
> https://bugs.launchpad.net/bugs/374900
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Tom Wright (twright-tdw) wrote :

Just to check, is everyone in agreement that in order to remove libfaac, the ffmpeg decoder would have to be included? Otherwise I predict some pretty serious fallout.

Reinhard Tartler (siretart) wrote :

Tom, libfaac is a pure encoder. This has nothing to do with libfaad,
which is an decoder for which I'm not aware of licensing issues so far.

libfaac on the other hand...

Savvas Radevic (medigeek) wrote :

> Just to check, is everyone in agreement that in order to remove libfaac,
> the ffmpeg decoder would have to be included? Otherwise I predict some
> pretty serious fallout.

I bet the answer would be "maybe as a backport". :)

@Jim, the unaware end-users (like you and me) have been informed:
http://www.omgubuntu.co.uk/2010/03/aac-codec-to-be-removed-from-ubuntu.html

As much as I hate it, it's a fact that there are 2+ licenses on
libfaac that make the software/package not distributable. It's also a
fact that end-users are now aware of the problematic license and will
either seek out a solution with nero[1] or wait for ffmpeg to roll out
a better open source alternative.

Mind you, while AAC encoding might not be available, AAC decoding
(playing aac files) will work (correct me if I'm wrong), since libfaad
is a different piece of software.

Savvas Radevic (medigeek) wrote :

> either seek out a solution with nero[1] [...]

[1] http://www.nero.com/enu/technologies-aac-codec.html

Ohh yeah and it's free one too.

Onkar Shinde (onkarshinde) wrote :

Do we have an agreement here that libfaac is getting removed from 10.04? If yes then I will upload new revision of gst-plugins-bad-multiverse0.10 with libfaac-dev build-dep removed.

Hans (henrik-nergard) wrote :

If you remove all codecs you just forcing people to go over to Linux Mint, who "works out of the box":
http://www.linuxmint.com/download.php

Why not do a special Ubuntu for USA and Japan and then the rest of the world can use a Ubuntu with all mediacodecs like Mint doing?After all most countries have different laws about this matter.

Pardus have also all mediacodecs included from the box:
http://www.pardus.org.tr/eng/

My point is do not things to difficult if you want Ubuntu to be the leading Linux distro in the future to.
Most Linux user have there eyes open for alternative and can change very quickly if necessary.

James Westby (james-w) wrote :

On Sat, 03 Apr 2010 07:58:20 -0000, Hans <email address hidden> wrote:
> If you remove all codecs you just forcing people to go over to Linux Mint, who "works out of the box":
> http://www.linuxmint.com/download.php
>
> Why not do a special Ubuntu for USA and Japan and then the rest of the
> world can use a Ubuntu with all mediacodecs like Mint doing?After all
> most countries have different laws about this matter.

This is not an issue of patents or anything like that. This is a license
conflict issue, meaning that the binaries produced from this source
package are believed to be not legally redistributable. That is believed
to apply regardless of the jurisdiction as it is concerned with
copyright and license law, and not patents.

You are welcome to have your views on what Ubuntu should do for the
benefit of its users, but please make sure you understand the issue at
hand when commenting on a particular bug report.

Thanks,

James

Hans (henrik-nergard) wrote :

Maybe I misunderstand it, but who knows if it a license conflict for sure? Nobody here seems to know it.
And are it valid in the rest of the world outside japan and USA?

Hans (henrik-nergard) wrote :

As you can see here it are different in different countries in this matter:
http://en.wikipedia.org/wiki/Software_patent#United_States
So before you remove anything is better to be 100% sure.

Savvas Radevic (medigeek) wrote :

Hans, software patent and software license are NOT the same.
Read the post above yours by James :)

On 4/4/10, Hans <email address hidden> wrote:
> As you can see here it are different in different countries in this matter:
> http://en.wikipedia.org/wiki/Software_patent#United_States
> So before you remove anything is better to be 100% sure.
>
> --
> Libfaac not LGPL
> https://bugs.launchpad.net/bugs/374900
> You received this bug notification because you are a direct subscriber
> of the bug.
>

--
Sent from my mobile device

This things are not easy. But I think it not Ubuntu developers job to make Ubuntu difficult to the ordinary PC user and helping Microsoft to find out everything for them.
If this bug report was not written had anyone ever noticed and think about it at all? And as Hans told maybe it are only valid in USA and Japan anyway. So why let the rest of the world suffer?

"United Kingdom patent law is interpreted to have the same effect as the European Patent Convention such that "programs for computers" are excluded from patentability to the extent that a patent application relates to a computer program "as such". Current case law in the UK states that an (alleged) invention will only be actually regarded as an invention if it provides a contribution that is not excluded and which is also technical. A computer program implementing a business process is therefore not an invention, but a computer program implementing an industrial process may well be."

Canonical are in UK so I think they would go under laws from UK to.

Chris Merrett (chrisfu) wrote :

Perhaps the interim solution to this is to have an additional, alternative ffmpeg package that is automatically built upon installation, eg. make-ffmpeg-nonfree-package. It works for Google Earth.

Although it's a slightly clunky way of solving the issue, and there are many build dependancies, it'll keep the functionality in Ubuntu without infringing anyone's I.P., or confusing folk that tend to shy away from getting their hands dirty in the console.

Any thoughts?

I'd love that option, Chrisfu. I'd be glad for anything that can make getting the nonfree ffmpeg codecs available to me.

Savvas Radevic (medigeek) wrote :

> Although it's a slightly clunky way of solving the issue, and there are
> many build dependancies, it'll keep the functionality in Ubuntu

Why not just contact medibuntu and ask for a binary distribution with
all the non-free license-arguable extras? I think that they already
have packages of disputable/non-free redistribution licenses.

Andres Mejia (amejia1) wrote :

Reinhard,

I looked at the current ffmpeg tree and found that the aacenc can now be enabled.
http://git.ffmpeg.org/?p=ffmpeg;a=blob;f=libavcodec/Makefile

Would it be possible to backport this to the the 0.5 branch (and thus patch current Debian/Ubuntu packages accordingly) or do users have to wait for ffmpeg-0.6?

I would be willing to help with backporting of this feature if desired.

Reinhard Tartler (siretart) wrote :

@archive-admins: Can you please give a status update on this bug?

AFAIUI, this package should either be removed or promoted to universe. multiverse is clearly the wrong place for this, as we the problems are redistributability matters, not licensing. If I got this wrong, please correct me.

James Westby (james-w) wrote :

On Fri, 28 May 2010 06:01:30 -0000, Reinhard Tartler <email address hidden> wrote:
> @archive-admins: Can you please give a status update on this bug?

The techboard deemed the packages suitable for release with lucid.

> AFAIUI, this package should either be removed or promoted to universe.
> multiverse is clearly the wrong place for this, as we the problems are
> redistributability matters, not licensing. If I got this wrong, please
> correct me.

I expect this means they would be happy with this then, but we might
want to confirm that with them.

Thanks,

James

Reinhard Tartler (siretart) wrote :

subscribing the tech board to this bug. It seems the archive administrators still wait on confirmation/input.

Any status update? Should this package be promoted to universe or removed from the archive?

Matt Zimmerman (mdz) on 2010-11-12
Changed in ubuntu-community:
assignee: nobody → Ubuntu Technical Board (techboard)
Matt Zimmerman (mdz) wrote :

Based on discussion in today's Technical Board meeting, and the content of this bug, we understand the root issue to be, in summary:

There appears to be code in libfaac which (as an exception to the prevailing license) is more restrictive than LGPL.

Accordingly, the following actions should be taken with respect to libfaac:

- Its copyright file should be updated to accurately reflect the applicable license(s). Currently, it states that the whole thing is *GPL*(!)
- This makes it GPL-incompatible, so it should be treated as such (no derived works including GPL code)
- It can stay in multiverse

If we've misunderstood or overlooked some part of the issue, please let us know.

Reinhard Tartler (siretart) wrote :

This explanation makes sense to me, thanks for working on it!

Unfortunately, this won't help with bug #412063, but that's life.

Kees Cook (kees) on 2011-03-10
Changed in ubuntu-community:
status: New → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package faac - 1.28-0ubuntu1

---------------
faac (1.28-0ubuntu1) oneiric; urgency=low

  * New upstream release. Package based on Debian Multimedia team git.
    (LP: #395902)
  * debian/copyright documents all applicable licenses. The package as a whole
    is not LGPL and will stay in multiverse. (LP: #374900)
  * Back to using a bundled internal copy of libmp4v2 in the frontend. The
    external libmp4v2 will eventually be removed.

faac (1.28-0fab3) unstable; urgency=low

  [ Andres Mejia ]
  * Various fixes for getting faac working on current Debian sid.
  * Include myself in Uploaders field.
  * Clarify comment about build fixes in patch.
  * Change this package section to non-free due to its conflicting
    licensing terms.
  * Don't include libtool file.

  [ Maia Kozheva ]
  * Add .gitignore.
  * Remove explicit quilt dependency, migrate to 3.0 source format.
  * Remove autoreconf.patch, using dh_autoreconf.
  * debian/control:
    - Reword binary package descriptions to remove initial articles.
    - Bump Standards-Version to 3.9.2.
    - Update maintainer field.
    - Add myself to uploaders.
  * debian/control, debian/rules:
    - Remove quilt, add dh-autoreconf support.
  * debian/faac.manpages, debian/manpages/faac.1:
    - Add manpage from Ubuntu version 1.26-0.1ubuntu2, with manpage hyphen
      issues corrected.

faac (1.28-0fab2) unstable; urgency=low

  * debian/control, debian/rules: Ported from debhelper (>= 7) to cdbs.
  * debian/control: Wrapped Build-Depends and Depends fields.

faac (1.28-0fab1) unstable; urgency=low

  * Initial release.
 -- Maia Kozheva <email address hidden> Thu, 09 Jun 2011 12:00:51 +0700

Changed in faac (Ubuntu):
status: Triaged → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers